require 'common/plugin'
require 'common/user'

module AgendavPlugin
  # Code that all Agendav plugins (Prune, Rm, Mv...) will
  # share.  That is, we implement the Plugin interface.
  include Plugin


  def initialize(cfg)
    @db_host = cfg.agendav_dbhost
    @db_port = cfg.agendav_dbport
    @db_opts = cfg.agendav_dbopts
    @db_tty  = cfg.agendav_dbtty
    @db_name = cfg.agendav_dbname
    @db_user = cfg.agendav_dbuser
    @db_pass = cfg.agendav_dbpass
  end


  def list_users()
    #
    # Produce a list of AgenDAV users. This is public because it's
    # useful in testing.
    #
    users = []

    connection = PGconn.connect(@db_host, @db_port, @db_opts, @db_tty,
                                @db_name, @db_user, @db_pass)

    sql_query  = '(SELECT username FROM prefs)'
    sql_query += 'UNION'
    sql_query += '(SELECT user_from FROM shared);'

    connection.query(sql_query) do |result|
      users = result.field_values('username')
    end

    connection.close()

    return users.map{ |u| User.new(u) }
  end

end
